Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 75772)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -2732,1003 +2685,501 @@
             break;
 
         case FileValidDataLengthInformation:
-            FIXME("STUB: FileValidDataLengthInformation\n");
+        {
+            TRACE("FileValidDataLengthInformation\n");
+
+            if (Irp->RequestorMode == UserMode && !(ccb->access & (FILE_WRITE_DATA | FILE_APPEND_DATA))) {
+                WARN("insufficient privileges\n");
+                Status = STATUS_ACCESS_DENIED;
+                break;
+            }
+
+            Status = set_valid_data_length_information(Vcb, Irp, IrpSp->FileObject);
+
             break;
-            
-#if (NTDDI_VERSION >= NTDDI_VISTA)
-        case FileNormalizedNameInformation:
-            FIXME("STUB: FileNormalizedNameInformation\n");
-            break;
-#endif
-            
-#if (NTDDI_VERSION >= NTDDI_WIN7)
-        case FileStandardLinkInformation:
-            FIXME("STUB: FileStandardLinkInformation\n");
-            break;
-            
-        case FileRemoteProtocolInformation:
-            TRACE("FileRemoteProtocolInformation\n");
-            break;
-#endif
-            
+        }
+
         default:
             WARN("unknown FileInformationClass %u\n", IrpSp->Parameters.SetFile.FileInformationClass);
     }
-    
+
 end:
     Irp->IoStatus.Status = Status;
 
+    TRACE("returning %08x\n", Status);
+
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
-    
-exit:
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
 }
 
-static NTSTATUS STDCALL fill_in_file_basic_information(FILE_BASIC_INFORMATION* fbi, INODE_ITEM* ii, LONG* length, fcb* fcb, file_ref* fileref) {
+static NTSTATUS fill_in_file_basic_information(FILE_BASIC_INFORMATION* fbi, INODE_ITEM* ii, LONG* length, fcb* fcb, file_ref* fileref) {
     RtlZeroMemory(fbi, sizeof(FILE_BASIC_INFORMATION));
-    
+
     *length -= sizeof(FILE_BASIC_INFORMATION);
-    
-    fbi->CreationTime.QuadPart = unix_time_to_win(&ii->otime);
-    fbi->LastAccessTime.QuadPart = unix_time_to_win(&ii->st_atime);
-    fbi->LastWriteTime.QuadPart = unix_time_to_win(&ii->st_mtime);
-    fbi->ChangeTime.QuadPart = unix_time_to_win(&ii->st_ctime);
-    
+
+    if (fcb == fcb->Vcb->dummy_fcb) {
+        LARGE_INTEGER time;
+
+        KeQuerySystemTime(&time);
+        fbi->CreationTime = fbi->LastAccessTime = fbi->LastWriteTime = fbi->ChangeTime = time;
+    } else {
+        fbi->CreationTime.QuadPart = unix_time_to_win(&ii->otime);
+        fbi->LastAccessTime.QuadPart = unix_time_to_win(&ii->st_atime);
+        fbi->LastWriteTime.QuadPart = unix_time_to_win(&ii->st_mtime);
+        fbi->ChangeTime.QuadPart = unix_time_to_win(&ii->st_ctime);
+    }
+
     if (fcb->ads) {
         if (!fileref || !fileref->parent) {
             ERR("no fileref for stream\n");
             return STATUS_INTERNAL_ERROR;
         } else
-            fbi->FileAttributes = fileref->parent->fcb->atts;
+            fbi->FileAttributes = fileref->parent->fcb->atts == 0 ? FILE_ATTRIBUTE_NORMAL : fileref->parent->fcb->atts;
     } else
-        fbi->FileAttributes = fcb->atts;
-    
+        fbi->FileAttributes = fcb->atts == 0 ? FILE_ATTRIBUTE_NORMAL : fcb->atts;
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL fill_in_file_network_open_information(FILE_NETWORK_OPEN_INFORMATION* fnoi, fcb* fcb, file_ref* fileref, LONG* length) {
+static NTSTATUS fill_in_file_network_open_information(FILE_NETWORK_OPEN_INFORMATION* fnoi, fcb* fcb, file_ref* fileref, LONG* length) {
     INODE_ITEM* ii;
-    
-    if (*length < sizeof(FILE_NETWORK_OPEN_INFORMATION)) {
+
+    if (*length < (LONG)sizeof(FILE_NETWORK_OPEN_INFORMATION)) {
         WARN("overflow\n");
         return STATUS_BUFFER_OVERFLOW;
     }
-    
+
     RtlZeroMemory(fnoi, sizeof(FILE_NETWORK_OPEN_INFORMATION));
-    
+
     *length -= sizeof(FILE_NETWORK_OPEN_INFORMATION);
-    
+
     if (fcb->ads) {
         if (!fileref || !fileref->parent) {
             ERR("no fileref for stream\n");
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         ii = &fileref->parent->fcb->inode_item;
     } else
         ii = &fcb->inode_item;
-    
-    fnoi->CreationTime.QuadPart = unix_time_to_win(&ii->otime);
-    fnoi->LastAccessTime.QuadPart = unix_time_to_win(&ii->st_atime);
-    fnoi->LastWriteTime.QuadPart = unix_time_to_win(&ii->st_mtime);
-    fnoi->ChangeTime.QuadPart = unix_time_to_win(&ii->st_ctime);
-    
+
+    if (fcb == fcb->Vcb->dummy_fcb) {
+        LARGE_INTEGER time;
+
+        KeQuerySystemTime(&time);
+        fnoi->CreationTime = fnoi->LastAccessTime = fnoi->LastWriteTime = fnoi->ChangeTime = time;
+    } else {
+        fnoi->CreationTime.QuadPart = unix_time_to_win(&ii->otime);
+        fnoi->LastAccessTime.QuadPart = unix_time_to_win(&ii->st_atime);
+        fnoi->LastWriteTime.QuadPart = unix_time_to_win(&ii->st_mtime);
+        fnoi->ChangeTime.QuadPart = unix_time_to_win(&ii->st_ctime);
+    }
+
     if (fcb->ads) {
         fnoi->AllocationSize.QuadPart = fnoi->EndOfFile.QuadPart = fcb->adsdata.Length;
-        fnoi->FileAttributes = fileref->parent->fcb->atts;
+        fnoi->FileAttributes = fileref->parent->fcb->atts == 0 ? FILE_ATTRIBUTE_NORMAL : fileref->parent->fcb->atts;
     } else {
-        fnoi->AllocationSize.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size);
+        fnoi->AllocationSize.QuadPart = fcb_alloc_size(fcb);
         fnoi->EndOfFile.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : fcb->inode_item.st_size;
-        fnoi->FileAttributes = fcb->atts;
+        fnoi->FileAttributes = fcb->atts == 0 ? FILE_ATTRIBUTE_NORMAL : fcb->atts;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL fill_in_file_standard_information(FILE_STANDARD_INFORMATION* fsi, fcb* fcb, file_ref* fileref, LONG* length) {
+static NTSTATUS fill_in_file_standard_information(FILE_STANDARD_INFORMATION* fsi, fcb* fcb, file_ref* fileref, LONG* length) {
     RtlZeroMemory(fsi, sizeof(FILE_STANDARD_INFORMATION));
-    
+
     *length -= sizeof(FILE_STANDARD_INFORMATION);
-    
+
     if (fcb->ads) {
         if (!fileref || !fileref->parent) {
             ERR("no fileref for stream\n");
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         fsi->AllocationSize.QuadPart = fsi->EndOfFile.QuadPart = fcb->adsdata.Length;
         fsi->NumberOfLinks = fileref->parent->fcb->inode_item.st_nlink;
-        fsi->Directory = S_ISDIR(fileref->parent->fcb->inode_item.st_mode);
+        fsi->Directory = FALSE;
     } else {
-        fsi->AllocationSize.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size);
+        fsi->AllocationSize.QuadPart = fcb_alloc_size(fcb);
         fsi->EndOfFile.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : fcb->inode_item.st_size;
         fsi->NumberOfLinks = fcb->inode_item.st_nlink;
         fsi->Directory = S_ISDIR(fcb->inode_item.st_mode);
     }
-    
+
     TRACE("length = %llu\n", fsi->EndOfFile.QuadPart);
-    
+
     fsi->DeletePending = fileref ? fileref->delete_on_close : FALSE;
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL fill_in_file_internal_information(FILE_INTERNAL_INFORMATION* fii, fcb* fcb, LONG* length) {
+static NTSTATUS fill_in_file_internal_information(FILE_INTERNAL_INFORMATION* fii, fcb* fcb, LONG* length) {
     *length -= sizeof(FILE_INTERNAL_INFORMATION);
-    
+
     fii->IndexNumber.QuadPart = make_file_id(fcb->subvol, fcb->inode);
-    
+
     return STATUS_SUCCESS;
-}  
-    
-static NTSTATUS STDCALL fill_in_file_ea_information(FILE_EA_INFORMATION* eai, fcb* fcb, LONG* length) {
+}
+
+static NTSTATUS fill_in_file_ea_information(FILE_EA_INFORMATION* eai, fcb* fcb, LONG* length) {
     *length -= sizeof(FILE_EA_INFORMATION);
-    
+
     /* This value appears to be the size of the structure NTFS stores on disk, and not,
      * as might be expected, the size of FILE_FULL_EA_INFORMATION (which is what we store).
      * The formula is 4 bytes as a header, followed by 5 + NameLength + ValueLength for each
      * item. */
-    
+
     eai->EaSize = fcb->ealen;
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL fill_in_file_access_information(FILE_ACCESS_INFORMATION* fai, LONG* length) {
-    *length -= sizeof(FILE_ACCESS_INFORMATION);
-    
-    fai->AccessFlags = GENERIC_READ;
-    
-    return STATUS_NOT_IMPLEMENTED;
-}
+static NTSTATUS fill_in_file_position_information(FILE_POSITION_INFORMATION* fpi, PFILE_OBJECT FileObject, LONG* length) {
+    RtlZeroMemory(fpi, sizeof(FILE_POSITION_INFORMATION));
 
-static NTSTATUS STDCALL fill_in_file_position_information(FILE_POSITION_INFORMATION* fpi, PFILE_OBJECT FileObject, LONG* length) {
-    RtlZeroMemory(fpi, sizeof(FILE_POSITION_INFORMATION));
-    
     *length -= sizeof(FILE_POSITION_INFORMATION);
-    
+
     fpi->CurrentByteOffset = FileObject->CurrentByteOffset;
-    
-    return STATUS_SUCCESS;
-}
 
-static NTSTATUS STDCALL fill_in_file_mode_information(FILE_MODE_INFORMATION* fmi, ccb* ccb, LONG* length) {
-    RtlZeroMemory(fmi, sizeof(FILE_MODE_INFORMATION));
-    
-    *length -= sizeof(FILE_MODE_INFORMATION);
-    
-    if (ccb->options & FILE_WRITE_THROUGH)
-        fmi->Mode |= FILE_WRITE_THROUGH;
-    
-    if (ccb->options & FILE_SEQUENTIAL_ONLY)
-        fmi->Mode |= FILE_SEQUENTIAL_ONLY;
-    
-    if (ccb->options & FILE_NO_INTERMEDIATE_BUFFERING)
-        fmi->Mode |= FILE_NO_INTERMEDIATE_BUFFERING;
-    
-    if (ccb->options & FILE_SYNCHRONOUS_IO_ALERT)
-        fmi->Mode |= FILE_SYNCHRONOUS_IO_ALERT;
-    
-    if (ccb->options & FILE_SYNCHRONOUS_IO_NONALERT)
-        fmi->Mode |= FILE_SYNCHRONOUS_IO_NONALERT;
-    
-    if (ccb->options & FILE_DELETE_ON_CLOSE)
-        fmi->Mode |= FILE_DELETE_ON_CLOSE;
-        
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL fill_in_file_alignment_information(FILE_ALIGNMENT_INFORMATION* fai, device_extension* Vcb, LONG* length) {
-    RtlZeroMemory(fai, sizeof(FILE_ALIGNMENT_INFORMATION));
-    
-    *length -= sizeof(FILE_ALIGNMENT_INFORMATION);
-    
-    fai->AlignmentRequirement = first_device(Vcb)->devobj->AlignmentRequirement;
-    
-    return STATUS_SUCCESS;
-}
-
-typedef struct {
-    file_ref* fileref;
-    LIST_ENTRY list_entry;
-} fileref_list;
-
-NTSTATUS fileref_get_filename(file_ref* fileref, PUNICODE_STRING fn, USHORT* name_offset) {
-    LIST_ENTRY fr_list, *le;
+NTSTATUS fileref_get_filename(file_ref* fileref, PUNICODE_STRING fn, USHORT* name_offset, ULONG* preqlen) {
     file_ref* fr;
     NTSTATUS Status;
-    ULONG len, i;
-    
+    ULONG reqlen = 0;
+    USHORT offset;
+    BOOL overflow = FALSE;
+
     // FIXME - we need a lock on filerefs' filepart
-    
+
     if (fileref == fileref->fcb->Vcb->root_fileref) {
-        fn->Buffer = ExAllocatePoolWithTag(PagedPool, sizeof(WCHAR), ALLOC_TAG);
-        if (!fn->Buffer) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        fn->Length = fn->MaximumLength = sizeof(WCHAR);
-        fn->Buffer[0] = '\\';
+        if (fn->MaximumLength >= sizeof(WCHAR)) {
+            fn->Buffer[0] = '\\';
+            fn->Length = sizeof(WCHAR);
 
-        if (name_offset)
-            *name_offset = 0;
+            if (name_offset)
+                *name_offset = 0;
 
-        return STATUS_SUCCESS;
+            return STATUS_SUCCESS;
+        } else {
+            if (preqlen)
+                *preqlen = sizeof(WCHAR);
+            fn->Length = 0;
+
+            return STATUS_BUFFER_OVERFLOW;
+        }
     }
-    
-    InitializeListHead(&fr_list);
-    
-    len = 0;
+
     fr = fileref;
-    
-    do {
-        fileref_list* frl;
-        
-        frl = ExAllocatePoolWithTag(PagedPool, sizeof(fileref_list), ALLOC_TAG);
-        if (!frl) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
+    offset = 0;
+
+    while (fr->parent) {
+        USHORT movelen;
+
+        if (!fr->dc)
+            return STATUS_INTERNAL_ERROR;
+
+        if (!overflow) {
+            if (fr->dc->name.Length + sizeof(WCHAR) + fn->Length > fn->MaximumLength)
+                overflow = TRUE;
         }
-        
-        frl->fileref = fr;
-        InsertTailList(&fr_list, &frl->list_entry);
-        
-        len += fr->filepart.Length;
-        
-        if (fr != fileref->fcb->Vcb->root_fileref)
-            len += sizeof(WCHAR);
-        
+
+        if (overflow)
+            movelen = fn->MaximumLength - fr->dc->name.Length - sizeof(WCHAR);
+        else
+            movelen = fn->Length;
+
+        if ((!overflow || fn->MaximumLength > fr->dc->name.Length + sizeof(WCHAR)) && movelen > 0) {
+            RtlMoveMemory(&fn->Buffer[(fr->dc->name.Length / sizeof(WCHAR)) + 1], fn->Buffer, movelen);
+            offset += fr->dc->name.Length + sizeof(WCHAR);
+        }
+
+        if (fn->MaximumLength >= sizeof(WCHAR)) {
+            fn->Buffer[0] = fr->fcb->ads ? ':' : '\\';
+            fn->Length += sizeof(WCHAR);
+
+            if (fn->MaximumLength > sizeof(WCHAR)) {
+                RtlCopyMemory(&fn->Buffer[1], fr->dc->name.Buffer, min(fr->dc->name.Length, fn->MaximumLength - sizeof(WCHAR)));
+                fn->Length += fr->dc->name.Length;
+            }
+
+            if (fn->Length > fn->MaximumLength) {
+                fn->Length = fn->MaximumLength;
+                overflow = TRUE;
+            }
+        }
+
+        reqlen += sizeof(WCHAR) + fr->dc->name.Length;
+
         fr = fr->parent;
-    } while (fr);
-    
-    fn->Buffer = ExAllocatePoolWithTag(PagedPool, len, ALLOC_TAG);
-    if (!fn->Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
     }
-    
-    fn->Length = fn->MaximumLength = len;
-    
-    i = 0;
-    
-    le = fr_list.Blink;
-    while (le != &fr_list) {
-        fileref_list* frl = CONTAINING_RECORD(le, fileref_list, list_entry);
-        
-        if (frl->fileref != fileref->fcb->Vcb->root_fileref) {
-            fn->Buffer[i] = frl->fileref->fcb->ads ? ':' : '\\';
-            i++;
-            
-            if (name_offset && frl->fileref == fileref)
-                *name_offset = i * sizeof(WCHAR);
-            
-            RtlCopyMemory(&fn->Buffer[i], frl->fileref->filepart.Buffer, frl->fileref->filepart.Length);
-            i += frl->fileref->filepart.Length / sizeof(WCHAR);
-        }
-        
-        le = le->Blink;
+
+    offset += sizeof(WCHAR);
+
+    if (overflow) {
+        if (preqlen)
+            *preqlen = reqlen;
+        Status = STATUS_BUFFER_OVERFLOW;
+    } else {
+        if (name_offset)
+            *name_offset = offset;
+
+        Status = STATUS_SUCCESS;
     }
-    
-    Status = STATUS_SUCCESS;
-    
-end:
-    while (!IsListEmpty(&fr_list)) {
-        fileref_list* frl;
-        
-        le = RemoveHeadList(&fr_list);
-        frl = CONTAINING_RECORD(le, fileref_list, list_entry);
-        
-        ExFreePool(frl);
-    }
-    
+
     return Status;
 }
 
-static NTSTATUS STDCALL fill_in_file_name_information(FILE_NAME_INFORMATION* fni, fcb* fcb, file_ref* fileref, LONG* length) {
-#ifdef _DEBUG
-    ULONG retlen = 0;
-#endif
+static NTSTATUS fill_in_file_name_information(FILE_NAME_INFORMATION* fni, fcb* fcb, file_ref* fileref, LONG* length) {
+    ULONG reqlen;
     UNICODE_STRING fn;
     NTSTATUS Status;
     static WCHAR datasuf[] = {':','$','D','A','T','A',0};
-    ULONG datasuflen = wcslen(datasuf) * sizeof(WCHAR);
-    
+    UINT16 datasuflen = (UINT16)wcslen(datasuf) * sizeof(WCHAR);
+
     if (!fileref) {
         ERR("called without fileref\n");
         return STATUS_INVALID_PARAMETER;
     }
-   
-    RtlZeroMemory(fni, sizeof(FILE_NAME_INFORMATION));
-    
+
     *length -= (LONG)offsetof(FILE_NAME_INFORMATION, FileName[0]);
-    
+
     TRACE("maximum length is %u\n", *length);
     fni->FileNameLength = 0;
-    
+
     fni->FileName[0] = 0;
-    
-    Status = fileref_get_filename(fileref, &fn, NULL);
-    if (!NT_SUCCESS(Status)) {
+
+    fn.Buffer = fni->FileName;
+    fn.Length = 0;
+    fn.MaximumLength = (UINT16)*length;
+
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
+    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
         ERR("fileref_get_filename returned %08x\n", Status);
         return Status;
     }
-    
-    if (*length >= (LONG)fn.Length) {
-        RtlCopyMemory(fni->FileName, fn.Buffer, fn.Length);
-#ifdef _DEBUG
-        retlen = fn.Length;
-#endif
-        *length -= fn.Length;
-    } else {
-        if (*length > 0) {
-            RtlCopyMemory(fni->FileName, fn.Buffer, *length);
-#ifdef _DEBUG
-            retlen = *length;
-#endif
-        }
-        *length = -1;
-    }
-    
-    fni->FileNameLength = fn.Length;
-    
+
     if (fcb->ads) {
-        if (*length >= (LONG)datasuflen) {
-            RtlCopyMemory(&fni->FileName[fn.Length / sizeof(WCHAR)], datasuf, datasuflen);
-#ifdef _DEBUG
-            retlen += datasuflen;
-#endif
-            *length -= datasuflen;
-        } else {
-            if (*length > 0) {
-                RtlCopyMemory(&fni->FileName[fn.Length / sizeof(WCHAR)], datasuf, *length);
-#ifdef _DEBUG
-                retlen += *length;
-#endif
+        if (Status == STATUS_BUFFER_OVERFLOW)
+            reqlen += datasuflen;
+        else {
+            if (fn.Length + datasuflen > fn.MaximumLength) {
+                RtlCopyMemory(&fn.Buffer[fn.Length / sizeof(WCHAR)], datasuf, fn.MaximumLength - fn.Length);
+                reqlen += datasuflen;
+                Status = STATUS_BUFFER_OVERFLOW;
+            } else {
+                RtlCopyMemory(&fn.Buffer[fn.Length / sizeof(WCHAR)], datasuf, datasuflen);
+                fn.Length += datasuflen;
             }
-            *length = -1;
         }
     }
-    
-    ExFreePool(fn.Buffer);
-    
-    TRACE("%.*S\n", retlen / sizeof(WCHAR), fni->FileName);
 
-    return STATUS_SUCCESS;
+    if (Status == STATUS_BUFFER_OVERFLOW) {
+        *length = -1;
+        fni->FileNameLength = reqlen;
+        TRACE("%.*S (truncated)\n", fn.Length / sizeof(WCHAR), fn.Buffer);
+    } else {
+        *length -= fn.Length;
+        fni->FileNameLength = fn.Length;
+        TRACE("%.*S\n", fn.Length / sizeof(WCHAR), fn.Buffer);
+    }
+
+    return Status;
 }
 
-static NTSTATUS STDCALL fill_in_file_attribute_information(FILE_ATTRIBUTE_TAG_INFORMATION* ati, fcb* fcb, file_ref* fileref, PIRP Irp, LONG* length) {
+static NTSTATUS fill_in_file_attribute_information(FILE_ATTRIBUTE_TAG_INFORMATION* ati, fcb* fcb, ccb* ccb, PIRP Irp, LONG* length) {
     *length -= sizeof(FILE_ATTRIBUTE_TAG_INFORMATION);
-    
+
     if (fcb->ads) {
-        if (!fileref || !fileref->parent) {
+        if (!ccb->fileref || !ccb->fileref->parent) {
             ERR("no fileref for stream\n");
             return STATUS_INTERNAL_ERROR;
         }
-        
-        ati->FileAttributes = fileref->parent->fcb->atts;
+
+        ati->FileAttributes = ccb->fileref->parent->fcb->atts;
     } else
         ati->FileAttributes = fcb->atts;
-    
+
     if (!(ati->FileAttributes & FILE_ATTRIBUTE_REPARSE_POINT))
         ati->ReparseTag = 0;
     else
-        ati->ReparseTag = get_reparse_tag(fcb->Vcb, fcb->subvol, fcb->inode, fcb->type, fcb->atts, Irp);
-    
+        ati->ReparseTag = get_reparse_tag(fcb->Vcb, fcb->subvol, fcb->inode, fcb->type, fcb->atts, ccb->lxss, Irp);
+
     return STATUS_SUCCESS;
 }
 
-typedef struct {
-    UNICODE_STRING name;
-    UINT64 size;
-    BOOL ignore;
-    LIST_ENTRY list_entry;
-} stream_info;
-
-static NTSTATUS STDCALL fill_in_file_stream_information(FILE_STREAM_INFORMATION* fsi, file_ref* fileref, PIRP Irp, LONG* length) {
-    ULONG reqsize;
-    LIST_ENTRY streamlist, *le;
+static NTSTATUS fill_in_file_stream_information(FILE_STREAM_INFORMATION* fsi, file_ref* fileref, LONG* length) {
+    LONG reqsize;
+    LIST_ENTRY* le;
     FILE_STREAM_INFORMATION *entry, *lastentry;
     NTSTATUS Status;
-    KEY searchkey;
-    traverse_ptr tp, next_tp;
-    BOOL b;
-    stream_info* si;
-    
-    static WCHAR datasuf[] = {':','$','D','A','T','A',0};
-    static char xapref[] = "user.";
+
+    static WCHAR datasuf[] = L":$DATA";
     UNICODE_STRING suf;
-    
+
     if (!fileref) {
         ERR("fileref was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
-    InitializeListHead(&streamlist);
-    
-    ExAcquireResourceSharedLite(&fileref->fcb->Vcb->tree_lock, TRUE);
-    ExAcquireResourceSharedLite(fileref->fcb->Header.Resource, TRUE);
-    
+
     suf.Buffer = datasuf;
-    suf.Length = suf.MaximumLength = wcslen(datasuf) * sizeof(WCHAR);
-    
-    searchkey.obj_id = fileref->fcb->inode;
-    searchkey.obj_type = TYPE_XATTR_ITEM;
-    searchkey.offset = 0;
+    suf.Length = suf.MaximumLength = (UINT16)wcslen(datasuf) * sizeof(WCHAR);
 
-    Status = find_item(fileref->fcb->Vcb, fileref->fcb->subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
-    
-    if (fileref->fcb->type != BTRFS_TYPE_DIRECTORY) {
-        si = ExAllocatePoolWithTag(PagedPool, sizeof(stream_info), ALLOC_TAG);
-        if (!si) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
-        }
-        
-        si->name.Length = si->name.MaximumLength = 0;
-        si->name.Buffer = NULL;
-        si->size = fileref->fcb->inode_item.st_size;
-        si->ignore = FALSE;
-        
-        InsertTailList(&streamlist, &si->list_entry);
-    }
-    
-    do {
-        if (tp.item->key.obj_id == fileref->fcb->inode && tp.item->key.obj_type == TYPE_XATTR_ITEM) {
-            if (tp.item->size < sizeof(DIR_ITEM)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
-            } else {
-                ULONG len = tp.item->size;
-                DIR_ITEM* xa = (DIR_ITEM*)tp.item->data;
-                ULONG stringlen;
-                
-                do {
-                    if (len < sizeof(DIR_ITEM) || len < sizeof(DIR_ITEM) - 1 + xa->m + xa->n) {
-                        ERR("(%llx,%x,%llx) was truncated\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                        break;
-                    }
-                    
-                    if (xa->n > strlen(xapref) && RtlCompareMemory(xa->name, xapref, strlen(xapref)) == strlen(xapref) &&
-                        (tp.item->key.offset != EA_DOSATTRIB_HASH || xa->n != strlen(EA_DOSATTRIB) || RtlCompareMemory(xa->name, EA_DOSATTRIB, xa->n) != xa->n) &&
-                        (tp.item->key.offset != EA_EA_HASH || xa->n != strlen(EA_EA) || RtlCompareMemory(xa->name, EA_EA, xa->n) != xa->n)
-                    ) {
-                        Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, &xa->name[strlen(xapref)], xa->n - strlen(xapref));
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                            goto end;
-                        }
-                        
-                        si = ExAllocatePoolWithTag(PagedPool, sizeof(stream_info), ALLOC_TAG);
-                        if (!si) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        si->name.Buffer = ExAllocatePoolWithTag(PagedPool, stringlen, ALLOC_TAG);
-                        if (!si->name.Buffer) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(si);
-                            goto end;
-                        }
-                            
-                        Status = RtlUTF8ToUnicodeN(si->name.Buffer, stringlen, &stringlen, &xa->name[strlen(xapref)], xa->n - strlen(xapref));
-                        
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                            ExFreePool(si->name.Buffer);
-                            ExFreePool(si);
-                            goto end;
-                        }
-                        
-                        si->name.Length = si->name.MaximumLength = stringlen;
-                        
-                        si->size = xa->m;
-                        
-                        si->ignore = FALSE;
-                        
-                        TRACE("stream name = %.*S (length = %u)\n", si->name.Length / sizeof(WCHAR), si->name.Buffer, si->name.Length / sizeof(WCHAR));
-                        
-                        InsertTailList(&streamlist, &si->list_entry);
-                    }
-                    
-                    len -= sizeof(DIR_ITEM) - sizeof(char) + xa->n + xa->m;
-                    xa = (DIR_ITEM*)&xa->name[xa->n + xa->m]; // FIXME - test xattr hash collisions work
-                } while (len > 0);
-            }
-        }
-        
-        b = find_next_item(fileref->fcb->Vcb, &tp, &next_tp, FALSE, Irp);
-        if (b) {
-            tp = next_tp;
-            
-            if (next_tp.item->key.obj_id > fileref->fcb->inode || next_tp.item->key.obj_type > TYPE_XATTR_ITEM)
-                break;
-        }
-    } while (b);
-    
-    ExAcquireResourceSharedLite(&fileref->nonpaged->children_lock, TRUE);
-    
-    le = fileref->children.Flink;
-    while (le != &fileref->children) {
-        file_ref* fr = CONTAINING_RECORD(le, file_ref, list_entry);
-        
-        if (fr->fcb && fr->fcb->ads) {
-            LIST_ENTRY* le2 = streamlist.Flink;
-            BOOL found = FALSE;
-            
-            while (le2 != &streamlist) {
-                si = CONTAINING_RECORD(le2, stream_info, list_entry);
-                
-                if (si && si->name.Buffer && si->name.Length == fr->filepart.Length &&
-                    RtlCompareMemory(si->name.Buffer, fr->filepart.Buffer, si->name.Length) == si->name.Length) {
-                    
-                    si->size = fr->fcb->adsdata.Length;
-                    si->ignore = fr->fcb->deleted;
-                    
-                    found = TRUE;
-                    break;
-                }
-                
-                le2 = le2->Flink;
-            }
-            
-            if (!found && !fr->fcb->deleted) {
-                si = ExAllocatePoolWithTag(PagedPool, sizeof(stream_info), ALLOC_TAG);
-                if (!si) {
-                    ERR("out of memory\n");
-                    Status = STATUS_INSUFFICIENT_RESOURCES;
-                    goto end;
-                }
-                
-                si->name.Length = si->name.MaximumLength = fr->filepart.Length;
-                
-                si->name.Buffer = ExAllocatePoolWithTag(PagedPool, si->name.MaximumLength, ALLOC_TAG);
-                if (!si->name.Buffer) {
-                    ERR("out of memory\n");
-                    Status = STATUS_INSUFFICIENT_RESOURCES;
-                    ExFreePool(si);
-                    goto end;
-                }
-                
-                RtlCopyMemory(si->name.Buffer, fr->filepart.Buffer, fr->filepart.Length);
-                
-                si->size = fr->fcb->adsdata.Length;
-                si->ignore = FALSE;
-                
-                InsertTailList(&streamlist, &si->list_entry);
-            }
-        }
-        
+    if (fileref->fcb->type != BTRFS_TYPE_DIRECTORY)
+        reqsize = sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR);
+    else
+        reqsize = 0;
+
+    ExAcquireResourceSharedLite(&fileref->fcb->nonpaged->dir_children_lock, TRUE);
+
+    le = fileref->fcb->dir_children_index.Flink;
+    while (le != &fileref->fcb->dir_children_index) {
+        dir_child* dc = CONTAINING_RECORD(le, dir_child, list_entry_index);
+
+        if (dc->index == 0) {
+            reqsize = (ULONG)sector_align(reqsize, sizeof(LONGLONG));
+            reqsize += sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + dc->name.Length;
+        } else
+            break;
+
         le = le->Flink;
     }
-    
-    ExReleaseResourceLite(&fileref->nonpaged->children_lock);
-    
-    reqsize = 0;
-    
-    le = streamlist.Flink;
-    while (le != &streamlist) {
-        si = CONTAINING_RECORD(le, stream_info, list_entry);
-        
-        if (!si->ignore) {
-            reqsize = sector_align(reqsize, sizeof(LONGLONG));
-            reqsize += sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + si->name.Length;
-        }
 
-        le = le->Flink;
-    }        
-    
     TRACE("length = %i, reqsize = %u\n", *length, reqsize);
-    
+
     if (reqsize > *length) {
         Status = STATUS_BUFFER_OVERFLOW;
         goto end;
     }
-    
+
     entry = fsi;
     lastentry = NULL;
-    
-    le = streamlist.Flink;
-    while (le != &streamlist) {
-        si = CONTAINING_RECORD(le, stream_info, list_entry);
-        
-        if (!si->ignore) {
+
+    if (fileref->fcb->type != BTRFS_TYPE_DIRECTORY) {
+        ULONG off;
+
+        entry->NextEntryOffset = 0;
+        entry->StreamNameLength = suf.Length + sizeof(WCHAR);
+        entry->StreamSize.QuadPart = fileref->fcb->inode_item.st_size;
+        entry->StreamAllocationSize.QuadPart = fcb_alloc_size(fileref->fcb);
+
+        entry->StreamName[0] = ':';
+        RtlCopyMemory(&entry->StreamName[1], suf.Buffer, suf.Length);
+
+        off = (ULONG)sector_align(sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR), sizeof(LONGLONG));
+
+        lastentry = entry;
+        entry = (FILE_STREAM_INFORMATION*)((UINT8*)entry + off);
+    }
+
+    le = fileref->fcb->dir_children_index.Flink;
+    while (le != &fileref->fcb->dir_children_index) {
+        dir_child* dc = CONTAINING_RECORD(le, dir_child, list_entry_index);
+
+        if (dc->index == 0) {
             ULONG off;
-            
+
             entry->NextEntryOffset = 0;
-            entry->StreamNameLength = si->name.Length + suf.Length + sizeof(WCHAR);
-            entry->StreamSize.QuadPart = si->size;
-            
-            if (le == streamlist.Flink)
-                entry->StreamAllocationSize.QuadPart = sector_align(fileref->fcb->inode_item.st_size, fileref->fcb->Vcb->superblock.sector_size);
+            entry->StreamNameLength = dc->name.Length + suf.Length + sizeof(WCHAR);
+
+            if (dc->fileref)
+                entry->StreamSize.QuadPart = dc->fileref->fcb->adsdata.Length;
             else
-                entry->StreamAllocationSize.QuadPart = si->size;
-            
+                entry->StreamSize.QuadPart = dc->size;
+
+            entry->StreamAllocationSize.QuadPart = entry->StreamSize.QuadPart;
+
             entry->StreamName[0] = ':';
-            
-            if (si->name.Length > 0)
-                RtlCopyMemory(&entry->StreamName[1], si->name.Buffer, si->name.Length);
-            
-            RtlCopyMemory(&entry->StreamName[1 + (si->name.Length / sizeof(WCHAR))], suf.Buffer, suf.Length);
-            
+
+            RtlCopyMemory(&entry->StreamName[1], dc->name.Buffer, dc->name.Length);
+            RtlCopyMemory(&entry->StreamName[1 + (dc->name.Length / sizeof(WCHAR))], suf.Buffer, suf.Length);
+
             if (lastentry)
-                lastentry->NextEntryOffset = (UINT8*)entry - (UINT8*)lastentry;
-            
-            off = sector_align(sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + si->name.Length, sizeof(LONGLONG));
+                lastentry->NextEntryOffset = (UINT32)((UINT8*)entry - (UINT8*)lastentry);
 
+            off = (ULONG)sector_align(sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + dc->name.Length, sizeof(LONGLONG));
+
             lastentry = entry;
             entry = (FILE_STREAM_INFORMATION*)((UINT8*)entry + off);
-        }
-        
+        } else
+            break;
+
         le = le->Flink;
     }
-    
+
     *length -= reqsize;
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
-    while (!IsListEmpty(&streamlist)) {
-        le = RemoveHeadList(&streamlist);
-        si = CONTAINING_RECORD(le, stream_info, list_entry);
-        
-        if (si->name.Buffer)
-            ExFreePool(si->name.Buffer);
-        
-        ExFreePool(si);
-    }
-    
-    ExReleaseResourceLite(fileref->fcb->Header.Resource);
-    ExReleaseResourceLite(&fileref->fcb->Vcb->tree_lock);
-    
+    ExReleaseResourceLite(&fileref->fcb->nonpaged->dir_children_lock);
+
     return Status;
 }
 
 #ifndef __REACTOS__
-static NTSTATUS STDCALL fill_in_file_standard_link_information(FILE_STANDARD_LINK_INFORMATION* fsli, fcb* fcb, file_ref* fileref, LONG* length) {
+static NTSTATUS fill_in_file_standard_link_information(FILE_STANDARD_LINK_INFORMATION* fsli, fcb* fcb, file_ref* fileref, LONG* length) {
     TRACE("FileStandardLinkInformation\n");
-    
+
     // FIXME - NumberOfAccessibleLinks should subtract open links which have been marked as delete_on_close
-    
+
     fsli->NumberOfAccessibleLinks = fcb->inode_item.st_nlink;
     fsli->TotalNumberOfLinks = fcb->inode_item.st_nlink;
     fsli->DeletePending = fileref ? fileref->delete_on_close : FALSE;
-    fsli->Directory = fcb->type == BTRFS_TYPE_DIRECTORY ? TRUE : FALSE;
-    
+    fsli->Directory = (!fcb->ads && fcb->type == BTRFS_TYPE_DIRECTORY) ? TRUE : FALSE;
+
     *length -= sizeof(FILE_STANDARD_LINK_INFORMATION);
-    
+
     return STATUS_SUCCESS;
 }
 #endif /* __REACTOS__ */
 
-typedef struct {
-    UNICODE_STRING name;
-    UINT64 inode;
-    LIST_ENTRY list_entry;
-} name_bit;
-
-static NTSTATUS get_subvol_path(device_extension* Vcb, root* subvol, PIRP Irp) {
-    KEY searchkey;
-    traverse_ptr tp;
+NTSTATUS open_fileref_by_inode(_Requires_exclusive_lock_held_(_Curr_->fcb_lock) device_extension* Vcb,
+                               root* subvol, UINT64 inode, file_ref** pfr, PIRP Irp) {
     NTSTATUS Status;
-    LIST_ENTRY* le;
-    root* parsubvol;
-    UNICODE_STRING dirpath;
-    ROOT_REF* rr;
-    ULONG namelen;
-    
-    // FIXME - add subvol->parent field
-    
-    if (subvol == Vcb->root_fileref->fcb->subvol) {
-        subvol->path.Length = subvol->path.MaximumLength = sizeof(WCHAR);
-        subvol->path.Buffer = ExAllocatePoolWithTag(PagedPool, subvol->path.Length, ALLOC_TAG);
-        subvol->path.Buffer[0] = '\\';
-        return STATUS_SUCCESS;
-    }
-    
-    searchkey.obj_id = subvol->id;
-    searchkey.obj_type = TYPE_ROOT_BACKREF;
-    searchkey.offset = 0xffffffffffffffff;
-    
-    Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        return Status;
-    }
-    
-    if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) { // top subvol
-        subvol->path.Length = subvol->path.MaximumLength = sizeof(WCHAR);
-        subvol->path.Buffer = ExAllocatePoolWithTag(PagedPool, subvol->path.Length, ALLOC_TAG);
-        subvol->path.Buffer[0] = '\\';
-        return STATUS_SUCCESS;
-    }
-    
-    if (tp.item->size < sizeof(ROOT_REF)) {
-        ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(ROOT_REF));
-        return STATUS_INTERNAL_ERROR;
-    }
-    
-    rr = (ROOT_REF*)tp.item->data;
-    
-    if (tp.item->size < sizeof(ROOT_REF) - 1 + rr->n) {
-        ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(ROOT_REF) - 1 + rr->n);
-        return STATUS_INTERNAL_ERROR;
-    }
-    
-    le = Vcb->roots.Flink;
-
-    parsubvol = NULL;
-
-    while (le != &Vcb->roots) {
-        root* r2 = CONTAINING_RECORD(le, root, list_entry);
-        
-        if (r2->id == tp.item->key.offset) {
-            parsubvol = r2;
-            break;
-        }
-        
-        le = le->Flink;
-    }
-    
-    if (!parsubvol) {
-        ERR("unable to find subvol %llx\n", tp.item->key.offset);
-        return STATUS_INTERNAL_ERROR;
-    }
-    
-    // FIXME - recursion
-
-    Status = get_inode_dir_path(Vcb, parsubvol, rr->dir, &dirpath, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("get_inode_dir_path returned %08x\n", Status);
-        return Status;
-    }
-    
-    Status = RtlUTF8ToUnicodeN(NULL, 0, &namelen, rr->name, rr->n);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-        goto end;
-    }
-    
-    if (namelen == 0) {
-        ERR("length was 0\n");
-        Status = STATUS_INTERNAL_ERROR;
-        goto end;
-    }
-    
-    subvol->path.Length = subvol->path.MaximumLength = dirpath.Length + namelen;
-    subvol->path.Buffer = ExAllocatePoolWithTag(PagedPool, subvol->path.Length, ALLOC_TAG);
-    
-    if (!subvol->path.Buffer) {  
-        ERR("out of memory\n");
-        
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(subvol->path.Buffer, dirpath.Buffer, dirpath.Length);
-        
-    Status = RtlUTF8ToUnicodeN(&subvol->path.Buffer[dirpath.Length / sizeof(WCHAR)], namelen, &namelen, rr->name, rr->n);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-        goto end;
-    }
-    
-    Status = STATUS_SUCCESS;
-    
-end:
-    if (dirpath.Buffer)
-        ExFreePool(dirpath.Buffer);
-    
-    if (!NT_SUCCESS(Status) && subvol->path.Buffer) {
-        ExFreePool(subvol->path.Buffer);
-        subvol->path.Buffer = NULL;
-    }
-    
-    return Status;
-}
-
-static NTSTATUS get_inode_dir_path(device_extension* Vcb, root* subvol, UINT64 inode, PUNICODE_STRING us, PIRP Irp) {
-    KEY searchkey;
-    NTSTATUS Status;
-    UINT64 in;
-    traverse_ptr tp;
-    LIST_ENTRY name_trail, *le;
-    UINT16 levels = 0;
-    UINT32 namelen = 0;
-    WCHAR* usbuf;
-    
-    InitializeListHead(&name_trail);
-    
-    in = inode;
-    
-    // FIXME - start with subvol prefix
-    if (!subvol->path.Buffer) {
-        Status = get_subvol_path(Vcb, subvol, Irp);
-        if (!NT_SUCCESS(Status)) {
-            ERR("get_subvol_path returned %08x\n", Status);
-            return Status;
-        }
-    }
-    
-    while (in != subvol->root_item.objid) {
-        searchkey.obj_id = in;
-        searchkey.obj_type = TYPE_INODE_EXTREF;
-        searchkey.offset = 0xffffffffffffffff;
-        
-        Status = find_item(Vcb, subvol, &tp, &searchkey, FALSE, Irp);
-        if (!NT_SUCCESS(Status)) {
-            ERR("error - find_item returned %08x\n", Status);
-            goto end;
-        }
-        
-        if (tp.item->key.obj_id != searchkey.obj_id) {
-            ERR("could not find INODE_REF for inode %llx in subvol %llx\n", searchkey.obj_id, subvol->id);
-            Status = STATUS_INTERNAL_ERROR;
-            goto end;
-        }
-        
-        if (tp.item->key.obj_type == TYPE_INODE_REF) {
-            INODE_REF* ir = (INODE_REF*)tp.item->data;
-            name_bit* nb;
-            ULONG len;
-            
-            if (tp.item->size < sizeof(INODE_REF)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(INODE_REF));
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            if (tp.item->size < sizeof(INODE_REF) - 1 + ir->n) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(INODE_REF) - 1 + ir->n);
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            nb = ExAllocatePoolWithTag(PagedPool, sizeof(name_bit), ALLOC_TAG);
-            if (!nb) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end;
-            }
-            
-            nb->name.Buffer = NULL;
-            
-            InsertTailList(&name_trail, &nb->list_entry);
-            levels++;
-            
-            Status = RtlUTF8ToUnicodeN(NULL, 0, &len, ir->name, ir->n);
-            if (!NT_SUCCESS(Status)) {
-                ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-                goto end;
-            }
-            
-            if (len == 0) {
-                ERR("length was 0\n");
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            nb->name.Length = nb->name.MaximumLength = len;
-            
-            nb->name.Buffer = ExAllocatePoolWithTag(PagedPool, nb->name.Length, ALLOC_TAG);
-            if (!nb->name.Buffer) {  
-                ERR("out of memory\n");
-                
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end;
-            }
-                
-            Status = RtlUTF8ToUnicodeN(nb->name.Buffer, len, &len, ir->name, ir->n);
-            if (!NT_SUCCESS(Status)) {
-                ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-                goto end;
-            }
-            
-            in = tp.item->key.offset;
-            namelen += nb->name.Length;
-            
-//         } else if (tp.item->key.obj_type == TYPE_INODE_EXTREF) {
-//             // FIXME
-        } else {
-            ERR("could not find INODE_REF for inode %llx in subvol %llx\n", searchkey.obj_id, subvol->id);
-            Status = STATUS_INTERNAL_ERROR;
-            goto end;
-        }
-    }
-    
-    namelen += (levels + 1) * sizeof(WCHAR);
-    
-    us->Length = us->MaximumLength = namelen;
-    us->Buffer = ExAllocatePoolWithTag(PagedPool, us->Length, ALLOC_TAG);
-    
-    if (!us->Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    us->Buffer[0] = '\\';
-    usbuf = &us->Buffer[1];
-    
-    le = name_trail.Blink;
-    while (le != &name_trail) {
-        name_bit* nb = CONTAINING_RECORD(le, name_bit, list_entry);
-        
-        RtlCopyMemory(usbuf, nb->name.Buffer, nb->name.Length);
-        usbuf += nb->name.Length / sizeof(WCHAR);
-        
-        usbuf[0] = '\\';
-        usbuf++;
-        
-        le = le->Blink;
-    }
-    
-    Status = STATUS_SUCCESS;
-    
-end:
-    while (!IsListEmpty(&name_trail)) {
-        name_bit* nb = CONTAINING_RECORD(name_trail.Flink, name_bit, list_entry);
-        
-        if (nb->name.Buffer)
-            ExFreePool(nb->name.Buffer);
-        
-        RemoveEntryList(&nb->list_entry);
-        
-        ExFreePool(nb);
-    }
-
-    return Status;
-}
-
-NTSTATUS open_fileref_by_inode(device_extension* Vcb, root* subvol, UINT64 inode, file_ref** pfr, PIRP Irp) {
-    NTSTATUS Status;
     fcb* fcb;
-    hardlink* hl;
+    UINT64 parent = 0;
+    UNICODE_STRING name;
+    BOOL hl_alloc = FALSE;
     file_ref *parfr, *fr;
-    dir_child* dc = NULL;
-    
+
     Status = open_fcb(Vcb, subvol, inode, 0, NULL, NULL, &fcb, PagedPool, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("open_fcb returned %08x\n", Status);
         return Status;
     }
-    
+
     if (fcb->fileref) {
         *pfr = fcb->fileref;
         increase_fileref_refcount(fcb->fileref);
         return STATUS_SUCCESS;
     }
-    
+
     // find hardlink if fcb doesn't have any loaded
     if (IsListEmpty(&fcb->hardlinks)) {
         KEY searchkey;
         traverse_ptr tp;
-        
+
         searchkey.obj_id = fcb->inode;
         searchkey.obj_type = TYPE_INODE_EXTREF;
         searchkey.offset = 0xffffffffffffffff;
-        
+
         Status = find_item(Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("find_item returned %08x\n", Status);
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return Status;
         }
-        
+
         if (tp.item->key.obj_id == fcb->inode) {
             if (tp.item->key.obj_type == TYPE_INODE_REF) {
                 INODE_REF* ir;
